extends Node2D

# レイの開始座標
var start_position = Vector2(512, 300)
# レイの終端座標
var mouse_position = Vector2()

# 衝突しているかどうか
var is_hit = false

func _process(delta: float) -> void:
	# マウス座標をレイの終端とする
	mouse_position = get_viewport().get_mouse_position()
	update()
	
func _physics_process(delta: float) -> void:
	# レイの判定を行う
	var space_state = get_world_2d().direct_space_state
	var collision_mask = 0x7FFFFFFF # すべてのコリジョンとアタリ判定する
	var collide_with_bodies = true # body系と判定する
	var collide_wthi_areas = true # area2dと判定する
	
	var result = space_state.intersect_ray(start_position, mouse_position, [], collision_mask, collide_with_bodies, collide_wthi_areas)	
	if result:
		# 衝突した
		print("Hit at point: ", result.position)
	
	# 衝突フラグを格納する
	is_hit = result.empty() == false

func _draw() -> void:
	var color = Color.silver
	if is_hit:
		# 衝突していたら赤い線にする
		color = Color.red
	draw_line(start_position, mouse_position, color, 1)
